#!/bin/sh
########################################################################
#### script name: cover2kopete
#### version:     0.1
#### date:        2008-07-17
########################################################################
####  Copyright (C) André Wilke 2008
####  This program is free software; you can redistribute it and/or modify it under 
####  the terms of the GNU General Public License as published by the Free Software
####  Foundation; either version 2 of the License, or (at your option) any later version.
####
####  This program is distributed in the hope that it will be useful, but WITHOUT 
####  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
####  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
####
####  Get the full text of the GPL here:
####  http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
########################################################################
#### script author: André Wilke
####                http://home.arcor.de/andre-info (German)
####
####                contact:
####                   email:  andwil at noelves dot de
####                   Jabber: grosserboesertroll at amessage de
########################################################################
#### Description:
#### This script takes the cover-image of a song currently playing in
#### amarok and sets it as the global user photo in kopete.
#### If no song is being played it takes another one (see CONFIGURATION below).
####
#### Following packages needed: amarok, kopete, imagemagick
#### Script uses dcop! Tested with KDE 3.5.9, Amarok 1.4.9.1, Kopete 0.12.7
#########################################################################

# CONFIGURATION
normalphoto="/home/andre/kopete.png" # Which Photo should I use when Amarok isn't playing?
# END OF CONFIGURATION :-)

# Don't change anything beyond this line unless you know what you're doing
dropout="false"
while [ $dropout == "false" ]; do
   title=`dcop amarok player nowPlaying`
   current="$title"
      
   if [ "$(dcop amarok player nowPlaying)" = "" ]; then
      dcop kopete KopeteIface setGlobalPhoto $normalphoto
   else
      cover="$(dcop amarok player coverImage)"
      covername="${cover##*/}.png"
      newglobalphoto="/tmp/$covername"
      cp $cover /tmp/newphoto.png
      cd /tmp/
      convert newphoto.png -resize 75x75! resized_newphoto.png
      dcop kopete KopeteIface setGlobalPhoto /tmp/resized_newphoto.png
   fi

   while [ "$title" == "$current" ]; do
      sleep 10
      current=`dcop amarok player nowPlaying`
   done
done
